/*******************************************************************************


"This software program is licensed subject to the GNU General Public License 
(GPL). Version 2, June 1991, available at 
<http://www.fsf.org/copyleft/gpl.html>"

GNU General Public License 

Version 2, June 1991

Copyright (C) 1989, 1991 Free Software Foundation, Inc.  
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA

Everyone is permitted to copy and distribute verbatim copies of this license
document, but changing it is not allowed.

Preamble

The licenses for most software are designed to take away your freedom to 
share and change it. By contrast, the GNU General Public License is intended
to guarantee your freedom to share and change free software--to make sure 
the software is free for all its users. This General Public License applies 
to most of the Free Software Foundation's software and to any other program 
whose authors commit to using it. (Some other Free Software Foundation 
software is covered by the GNU Library General Public License instead.) You 
can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our
General Public Licenses are designed to make sure that you have the freedom 
to distribute copies of free software (and charge for this service if you 
wish), that you receive source code or can get it if you want it, that you 
can change the software or use pieces of it in new free programs; and that 
you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to 
deny you these rights or to ask you to surrender the rights. These 
restrictions translate to certain responsibilities for you if you distribute
copies of the software, or if you modify it.

For example, if you distribute copies of such a program, whether gratis or 
for a fee, you must give the recipients all the rights that you have. You 
must make sure that they, too, receive or can get the source code. And you 
must show them these terms so they know their rights.
 
We protect your rights with two steps: (1) copyright the software, and (2) 
offer you this license which gives you legal permission to copy, distribute 
and/or modify the software. 

Also, for each author's protection and ours, we want to make certain that 
everyone understands that there is no warranty for this free software. If 
the software is modified by someone else and passed on, we want its 
recipients to know that what they have is not the original, so that any 
problems introduced by others will not reflect on the original authors' 
reputations. 

Finally, any free program is threatened constantly by software patents. We 
wish to avoid the danger that redistributors of a free program will 
individually obtain patent licenses, in effect making the program 
proprietary. To prevent this, we have made it clear that any patent must be 
licensed for everyone's free use or not licensed at all. 

The precise terms and conditions for copying, distribution and modification 
follow. 

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License applies to any program or other work which contains a notice
   placed by the copyright holder saying it may be distributed under the 
   terms of this General Public License. The "Program", below, refers to any
   such program or work, and a "work based on the Program" means either the 
   Program or any derivative work under copyright law: that is to say, a 
   work containing the Program or a portion of it, either verbatim or with 
   modifications and/or translated into another language. (Hereinafter, 
   translation is included without limitation in the term "modification".) 
   Each licensee is addressed as "you". 

   Activities other than copying, distribution and modification are not 
   covered by this License; they are outside its scope. The act of running 
   the Program is not restricted, and the output from the Program is covered 
   only if its contents constitute a work based on the Program (independent 
   of having been made by running the Program). Whether that is true depends
   on what the Program does. 

1. You may copy and distribute verbatim copies of the Program's source code 
   as you receive it, in any medium, provided that you conspicuously and 
   appropriately publish on each copy an appropriate copyright notice and 
   disclaimer of warranty; keep intact all the notices that refer to this 
   License and to the absence of any warranty; and give any other recipients 
   of the Program a copy of this License along with the Program. 

   You may charge a fee for the physical act of transferring a copy, and you 
   may at your option offer warranty protection in exchange for a fee. 

2. You may modify your copy or copies of the Program or any portion of it, 
   thus forming a work based on the Program, and copy and distribute such 
   modifications or work under the terms of Section 1 above, provided that 
   you also meet all of these conditions: 

   * a) You must cause the modified files to carry prominent notices stating 
        that you changed the files and the date of any change. 

   * b) You must cause any work that you distribute or publish, that in 
        whole or in part contains or is derived from the Program or any part 
        thereof, to be licensed as a whole at no charge to all third parties
        under the terms of this License. 

   * c) If the modified program normally reads commands interactively when 
        run, you must cause it, when started running for such interactive 
        use in the most ordinary way, to print or display an announcement 
        including an appropriate copyright notice and a notice that there is
        no warranty (or else, saying that you provide a warranty) and that 
        users may redistribute the program under these conditions, and 
        telling the user how to view a copy of this License. (Exception: if 
        the Program itself is interactive but does not normally print such 
        an announcement, your work based on the Program is not required to 
        print an announcement.) 

   These requirements apply to the modified work as a whole. If identifiable 
   sections of that work are not derived from the Program, and can be 
   reasonably considered independent and separate works in themselves, then 
   this License, and its terms, do not apply to those sections when you 
   distribute them as separate works. But when you distribute the same 
   sections as part of a whole which is a work based on the Program, the 
   distribution of the whole must be on the terms of this License, whose 
   permissions for other licensees extend to the entire whole, and thus to 
   each and every part regardless of who wrote it. 

   Thus, it is not the intent of this section to claim rights or contest 
   your rights to work written entirely by you; rather, the intent is to 
   exercise the right to control the distribution of derivative or 
   collective works based on the Program. 

   In addition, mere aggregation of another work not based on the Program 
   with the Program (or with a work based on the Program) on a volume of a 
   storage or distribution medium does not bring the other work under the 
   scope of this License. 

3. You may copy and distribute the Program (or a work based on it, under 
   Section 2) in object code or executable form under the terms of Sections 
   1 and 2 above provided that you also do one of the following: 

   * a) Accompany it with the complete corresponding machine-readable source 
        code, which must be distributed under the terms of Sections 1 and 2 
        above on a medium customarily used for software interchange; or, 

   * b) Accompany it with a written offer, valid for at least three years, 
        to give any third party, for a charge no more than your cost of 
        physically performing source distribution, a complete machine-
        readable copy of the corresponding source code, to be distributed 
        under the terms of Sections 1 and 2 above on a medium customarily 
        used for software interchange; or, 

   * c) Accompany it with the information you received as to the offer to 
        distribute corresponding source code. (This alternative is allowed 
        only for noncommercial distribution and only if you received the 
        program in object code or executable form with such an offer, in 
        accord with Subsection b above.) 

   The source code for a work means the preferred form of the work for 
   making modifications to it. For an executable work, complete source code 
   means all the source code for all modules it contains, plus any 
   associated interface definition files, plus the scripts used to control 
   compilation and installation of the executable. However, as a special 
   exception, the source code distributed need not include anything that is 
   normally distributed (in either source or binary form) with the major 
   components (compiler, kernel, and so on) of the operating system on which
   the executable runs, unless that component itself accompanies the 
   executable. 

   If distribution of executable or object code is made by offering access 
   to copy from a designated place, then offering equivalent access to copy 
   the source code from the same place counts as distribution of the source 
   code, even though third parties are not compelled to copy the source 
   along with the object code. 

4. You may not copy, modify, sublicense, or distribute the Program except as
   expressly provided under this License. Any attempt otherwise to copy, 
   modify, sublicense or distribute the Program is void, and will 
   automatically terminate your rights under this License. However, parties 
   who have received copies, or rights, from you under this License will not
   have their licenses terminated so long as such parties remain in full 
   compliance. 

5. You are not required to accept this License, since you have not signed 
   it. However, nothing else grants you permission to modify or distribute 
   the Program or its derivative works. These actions are prohibited by law 
   if you do not accept this License. Therefore, by modifying or 
   distributing the Program (or any work based on the Program), you 
   indicate your acceptance of this License to do so, and all its terms and
   conditions for copying, distributing or modifying the Program or works 
   based on it. 

6. Each time you redistribute the Program (or any work based on the 
   Program), the recipient automatically receives a license from the 
   original licensor to copy, distribute or modify the Program subject to 
   these terms and conditions. You may not impose any further restrictions 
   on the recipients' exercise of the rights granted herein. You are not 
   responsible for enforcing compliance by third parties to this License. 

7. If, as a consequence of a court judgment or allegation of patent 
   infringement or for any other reason (not limited to patent issues), 
   conditions are imposed on you (whether by court order, agreement or 
   otherwise) that contradict the conditions of this License, they do not 
   excuse you from the conditions of this License. If you cannot distribute 
   so as to satisfy simultaneously your obligations under this License and 
   any other pertinent obligations, then as a consequence you may not 
   distribute the Program at all. For example, if a patent license would 
   not permit royalty-free redistribution of the Program by all those who 
   receive copies directly or indirectly through you, then the only way you 
   could satisfy both it and this License would be to refrain entirely from 
   distribution of the Program. 

   If any portion of this section is held invalid or unenforceable under any
   particular circumstance, the balance of the section is intended to apply
   and the section as a whole is intended to apply in other circumstances. 

   It is not the purpose of this section to induce you to infringe any 
   patents or other property right claims or to contest validity of any 
   such claims; this section has the sole purpose of protecting the 
   integrity of the free software distribution system, which is implemented 
   by public license practices. Many people have made generous contributions
   to the wide range of software distributed through that system in 
   reliance on consistent application of that system; it is up to the 
   author/donor to decide if he or she is willing to distribute software 
   through any other system and a licensee cannot impose that choice. 

   This section is intended to make thoroughly clear what is believed to be 
   a consequence of the rest of this License. 

8. If the distribution and/or use of the Program is restricted in certain 
   countries either by patents or by copyrighted interfaces, the original 
   copyright holder who places the Program under this License may add an 
   explicit geographical distribution limitation excluding those countries, 
   so that distribution is permitted only in or among countries not thus 
   excluded. In such case, this License incorporates the limitation as if 
   written in the body of this License. 

9. The Free Software Foundation may publish revised and/or new versions of 
   the General Public License from time to time. Such new versions will be 
   similar in spirit to the present version, but may differ in detail to 
   address new problems or concerns. 

   Each version is given a distinguishing version number. If the Program 
   specifies a version number of this License which applies to it and "any 
   later version", you have the option of following the terms and 
   conditions either of that version or of any later version published by 
   the Free Software Foundation. If the Program does not specify a version 
   number of this License, you may choose any version ever published by the 
   Free Software Foundation. 

10. If you wish to incorporate parts of the Program into other free programs
    whose distribution conditions are different, write to the author to ask 
    for permission. For software which is copyrighted by the Free Software 
    Foundation, write to the Free Software Foundation; we sometimes make 
    exceptions for this. Our decision will be guided by the two goals of 
    preserving the free status of all derivatives of our free software and 
    of promoting the sharing and reuse of software generally. 

   NO WARRANTY

11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY 
    FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN 
    OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES 
    PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
    EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE 
    ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH 
    YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
    NECESSARY SERVICING, REPAIR OR CORRECTION. 

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
    WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR 
    REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
    DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
    DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
    (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
    INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
    THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR 
    OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 

END OF TERMS AND CONDITIONS

How to Apply These Terms to Your New Programs

If you develop a new program, and you want it to be of the greatest 
possible use to the public, the best way to achieve this is to make it free 
software which everyone can redistribute and change under these terms. 

To do so, attach the following notices to the program. It is safest to 
attach them to the start of each source file to most effectively convey the
exclusion of warranty; and each file should have at least the "copyright" 
line and a pointer to where the full notice is found. 

one line to give the program's name and an idea of what it does.
Copyright (C) yyyy  name of author

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 2 of the License, or (at your option) 
any later version.

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 
Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Also add information on how to contact you by electronic and paper mail. 

If the program is interactive, make it output a short notice like this when 
it starts in an interactive mode: 

Gnomovision version 69, Copyright (C) year name of author Gnomovision comes 
with ABSOLUTELY NO WARRANTY; for details type 'show w'.  This is free 
software, and you are welcome to redistribute it under certain conditions; 
type 'show c' for details.

The hypothetical commands 'show w' and 'show c' should show the appropriate 
parts of the General Public License. Of course, the commands you use may be 
called something other than 'show w' and 'show c'; they could even be 
mouse-clicks or menu items--whatever suits your program. 

You should also get your employer (if you work as a programmer) or your 
school, if any, to sign a "copyright disclaimer" for the program, if 
necessary. Here is a sample; alter the names: 

Yoyodyne, Inc., hereby disclaims all copyright interest in the program 
'Gnomovision' (which makes passes at compilers) written by James Hacker.

signature of Ty Coon, 1 April 1989
Ty Coon, President of Vice

This General Public License does not permit incorporating your program into 
proprietary programs. If your program is a subroutine library, you may 
consider it more useful to permit linking proprietary applications with the 
library. If this is what you want to do, use the GNU Library General Public 
License instead of this License.

*******************************************************************************/

#ifndef _I2C_I825XX_H_
#define _I2C_I825XX_H_

#include <linux/pci.h>
#include <asm/types.h>
#include <asm/semaphore.h>
#include <linux/notifier.h>


#define LAVON	1
#define ANVIK	2

#define I825XX_BUS_TYPE	"Smbus"

/*------------------ 82551 definition ------------*/

#if BIT_ADAPTER == LAVON 

#define I82551_PM_OFFSET	0x1b
#define I82551_ASF_EN		0x04

#define I825XX_PCI_SMB_OFFSET	0x1f 

#define PCI_SMB_SCLI		0x01 //SMBus Clock input
#define PCI_SMB_SDAI		0x02 //SMBus Data inout 
#define PCI_SMB_SDAO		0x04 //SMBus Data output
#define PCI_SMB_REQ		0x08 //SMBus Isolation Request 
#define PCI_SMB_GNT		0x10 //SMBus Isolation Grant 
#define PCI_SMB_SCLO		0x20 //SMBus Clock output

#define I825XX_REG_SIZE		u8
#define I825XX_REG_WRITE	writeb
#define I825XX_REG_READ		readb

#define I825XX_DEV_NAME	"i82551"

inline int __init
i825xx_is_supported(struct pci_dev *pcid){
  
  u16 dev;
  u8 rev;
  pci_read_config_word(pcid, PCI_DEVICE_ID, &dev);  
  pci_read_config_byte(pcid, PCI_REVISION_ID, &rev);

  if((dev == 0x1052) || (dev == 0x1053) || (dev == 0x1055)  || (dev == 0x1066) || (dev == 0x1067) || (dev==0x1069)) {
    return 0;
  }

  return -1;
}

inline int
i825xx_smb_en(void * io_reg )
{
  return 0;
}

inline int __init
i825xx_smb_supported(void * io_reg){
 if( readb(io_reg + I82551_PM_OFFSET - 
	    I825XX_PCI_SMB_OFFSET ) & I82551_ASF_EN){
    return 0;
  }else{
    return -1;
  }
}

inline unsigned long __init
i825xx_iomem(struct pci_dev *pcid)
{
  return pci_resource_start(pcid, 0) &
    PCI_BASE_ADDRESS_MEM_MASK;
}

#ifndef I825XX_SYNC_WA

inline void 
i825xx_lock_hw_access(struct pci_dev *pcid, int lock)
{
  //e100_smbus_lock(pcid, lock);
}

inline int __init
i825xx_is_internal_PEC_supported(struct pci_dev *pcid){
  return 0;
}

#endif

/*------------------ 82543 definition ------------*/

#elif BIT_ADAPTER == ANVIK	

#ifndef I825XX_SYNC_WA
extern void e1000_smbus_lock(struct pci_dev *pcid, int lock);
#endif


#define I825XX_PCI_SMB_OFFSET	0x05820
#define I825XX_HOSTIF_OFFSET	0x08800

/* algo conrol ioctls for host interface access */
#define CMD_RESET_FIRMWARE	0x995
#define CMD_GET_VERSION		0x994
#define CMD_SET_CLASF_REG	0x993
#define CMD_GET_CLASF_REG	0x992
#define CMD_CHECK_HOSTIF	0x991
#define CMD_GET_ERRLOG_LENGTH	0x990
#define CMD_GET_ERRLOG_BUFFER	0x989
#define CMD_CLEAR_ERRLOG	0x988
#define CMD_SET_DHCP		0x987
#define CMD_GET_DHCP		0x986

#define HOST_NULL_CMD		0x00
#define HOST_RESET_CMD		0x02
#define HOST_VERSION_CMD	0x05
#define HOST_GET_REG_CMD	0x0d
#define HOST_SET_REG_CMD	0x0e
#define HOST_GET_LOG_CMD	0x12
#define HOST_CLEAR_LOG_CMD	0x14
#define HOST_GET_DHCP_CMD	0x03
#define HOST_SET_DHCP_CMD	0x04
#define HOST_CMD_DONE_BIT	0x80


#define HOST_CMD_WAIT	             0  
#define HOST_CMD_NO_WAIT             1

#define HOST_READY_DELAY             (HZ/10 + 1)
#define HOST_READY_RETRIES           10

#define HOST_CMD_RETRIES              100
#define HOST_CMD_RETRY_DELAY          (HZ/200 + 1)

#define HOST_CMD_RESET_DELAY          (3 * HZ)
#define HOST_CMD_CHECK_COMPLETE_DELAY (HZ/10 + 1)


#define PCI_SMB_EN		0x00000001 //SMBus enabled
#define PCI_ASF_EN		0x00000002 //SMBus staticly enalbed
#define PCI_ARP_EN		0x00002000 //ARP to smbus enable
#define PCI_SMB_REQ		0x01000000 //SMBus Isolation Request 
#define PCI_SMB_GNT		0x02000000 //SMBus Isolation Grant
#define PCI_SMB_SCLI	0x04000000 //SMBus Clock output
#define PCI_SMB_SDAI	0x08000000 //SMBus Data  output
#define PCI_SMB_SDAO	0x10000000 //SMBus Data  input
#define PCI_SMB_SCLO	0x20000000 //SMBus Clock input
#define PCI_HOST_READY  0x40000000 /* Host Interface Ready */

#define I825XX_REG_SIZE		u32

#ifdef SMB_TRACE_DEBUG
struct log_entry{
	suseconds_t time;
	u32          data;
	u8           type;
};

#define MAX_DATA_SIZE 20000

struct log_entry trace_buf[MAX_DATA_SIZE];

u32 trace_count = 0;

static inline void
trace(u32 data, u16 type)
{
	struct timeval time_struct;
	
	if (trace_count < MAX_DATA_SIZE){
		trace_buf[trace_count].data = data;
		trace_buf[trace_count].type = type;
		do_gettimeofday(&time_struct);
		trace_buf[trace_count].time = time_struct.tv_usec;
	}
	trace_count++;
}
#define I825XX_REG_WRITE(data,addr)	do { \
			writel(data,addr); \
			trace(data,1);}\
			while(0);

static inline u32 I825XX_REG_READ(void *addr)
{  
     u32 data;
     data=readl(addr);
     trace(data, 0);	
     return data;
}
/* algo conrol ioctls for trace */
#define CMD_GET_TRACE_BUFF 0x999
#define CMD_GET_TRACE_SIZE 0x998
#define CMD_RESET_TRACE    0x997

#else
#define trace(x,y) 
#define I825XX_REG_WRITE writel
#define I825XX_REG_READ readl
#endif /* SMB_TRACE_DEBUG */
#define I825XX_DEV_NAME	"i8254x"

inline int __init
i825xx_is_supported(struct pci_dev *pcid){
  u16 dev;
  pci_read_config_word(pcid, PCI_DEVICE_ID, &dev);
  
  if (((dev>=0x100E) && (dev<=0x1010)) ||
	  ((dev>=0x1013) && (dev<=0x101A)) ||
      (dev==0x101D) || (dev==0x101E) || (dev==0x1026) ||
	  ((dev>=0x1075) && (dev<=0x1079)) 
	  ) {
	  return 0;
  }

  return -1;
}

inline int __init
i825xx_is_internal_PEC_supported(struct pci_dev *pcid){
  u16 dev;
  pci_read_config_word(pcid, PCI_DEVICE_ID, &dev);
  
  if ( (dev==0x1013) || (dev==0x1014) ||
       (dev==0x1019) || (dev==0x1018) || (dev==0x101A) ||       
	 ((dev>=0x1075) && (dev<=0x1078))
	) {
	  return 1;
  }
  return 0;
}

inline int __init
i825xx_is_hostif_supported(struct pci_dev *pcid){
  u16 dev;
  pci_read_config_word(pcid, PCI_DEVICE_ID, &dev);
  
  if ( (dev==0x1013) || (dev==0x1014) ||
       (dev==0x1019) || (dev==0x1018) || (dev==0x101A) ||
	 ((dev>=0x1075) && (dev<=0x1078))
	) {
	  return 1;
  }
  return 0;
}


inline int
i825xx_smb_en(void *io_reg)
{
  if (readl(io_reg) & PCI_SMB_EN){
    return 0;
  }else{
    return -1;
  }
}

inline int __init
i825xx_smb_supported(void * io_reg){
  if(readl(io_reg) & PCI_ASF_EN){
    return 0;
  }else{
    return -1;
  }
}

inline unsigned long __init
i825xx_iomem(struct pci_dev *pcid)
{
  unsigned long raw_mem = pci_resource_start(pcid, 0);

#if BITS_PER_LONG == 64
  if(raw_mem & PCI_BASE_ADDRESS_MEM_TYPE_64){
    raw_mem |= (pci_resource_start(pcid, 1) << 32);
  }
#endif /* BITS_PER_LONG */

  return raw_mem & PCI_BASE_ADDRESS_MEM_MASK;
}

#ifdef I825XX_SYNC_WA
inline void
i825xx_arp_en(void * io_reg)
{
  u32 val = readl(io_reg);
  if(val & PCI_SMB_EN){
    val |= PCI_ARP_EN;
  }
  writel(val, io_reg);
}

#else

inline void 
i825xx_lock_hw_access(struct pci_dev *pcid, int lock)
{
  e1000_smbus_lock(pcid, lock);
}

#endif /* I825XX_SYNC_WA */


#else
#error "Undefined Adapter !"
#endif /* BIT_ADAPTER */

#ifdef I825XX_SYNC_WA
enum i825xx_pm_state  { I825XX_UP = 0, I825XX_DOWN };
#endif

enum i825xx_type { UNKNOWN = 0, INTERNAL, EXTERNAL };

struct i825xx_data {
  struct list_head	node;
  void * pci_smb_access;
  void * pci_hostif_access;
  struct pci_dev *	pcid;
  int 			initialized;
  struct i2c_adapter *	adap;		//ciruclar ptr 
#ifdef I825XX_SYNC_WA
  enum i825xx_pm_state  state;
#endif
  I825XX_REG_SIZE	pci_mask;	// maintain last smbus output line states
  int			flag_mask;	//Enables PEC on Tabor/TanaX

  enum i825xx_type	type;
  struct semaphore *	sem;
};
struct hostif_cmd{
	u8	command;
	u8	length;
	u8	reserved;
	u8	checksum;
	u8	buffer[252];
};
#endif /* _I2C_I825XX_H_ */

